## ros-melodic-rc-genicam-api 2.4.4

=== completion/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(completion CXX)

if (UNIX)
  set(ROS_DISTRO $ENV{ROS_DISTRO})

  if (ROS_DISTRO)
    set(COMPLETION_NAME "20.rc-gc.bash")
    install(FILES gc_bash_completion COMPONENT bin DESTINATION etc/catkin/profile.d RENAME ${COMPLETION_NAME})
    set(conffiles etc/catkin/profile.d/${COMPLETION_NAME} PARENT_SCOPE)
  else ()
    set(COMPLETION_NAME "gc_bash_completion")
    install(FILES gc_bash_completion COMPONENT bin DESTINATION /etc/bash_completion.d RENAME ${COMPLETION_NAME})
    set(conffiles /etc/bash_completion.d/${COMPLETION_NAME} PARENT_SCOPE)
  endif ()

endif (UNIX)
